// **************************************************************
//                       asynsrv.c
//  This program functions as an Asynchronous  Communication Server
//  Utility in Windows environment.  Please read the utility's manual
//  to get all needed information of haw to use the utility.
//
//  Note: To run the utility, the following DLLs should be located
//  in the current directory or in the directory listed in the PATH
//  environment variable:
//      ASYNMDI.DLL
//     "UserExitName".DLL
//
//  ------------------- Modefication Log ------------------------
//   DATE          PROGRAMMER               DESCRIPTION OF WORK
//  July, 1992     I. Livshin                   Development
//
// **************************************************************

#include <windows.h>
#define  DBMSWIN            // DBLIB Program is windows apps.
#include <sqlfront.h>
#include <sqldb.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys\types.h>
#include <sys\stat.h>

#define   MAXLEN  300
#define   MAX_HOST_BLOCK_SIZE 32005

typedef struct                     //  Parameters passed to the
  {                                 //  User Exit Routine, that
    char UserErrCode[5];            //  mast be locked;
    char Cmd_ResultFileName[110];
  }
   UserParm;

typedef UserParm FAR * LPUSERPARM;



// **************************************************************
//    *** Global variables ***
// **************************************************************

int (FAR PASCAL *lptrAsynUsr) (LPSTR, int, LPSTR, LPSTR);
HANDLE      hLibrary;
HANDLE     hUserParm;      // Variables used for allocating and
LPUSERPARM  lpUserParm;     // locking the UserParm structure

LPSTR lpHostBlock;          // Buffer to keep Host block locked
HANDLE hHostBlock;          // Corresponding pointer

char WorkBuffer[59];
char szIconName1[] = "resourc1";
char szIconName2[] = "resourc2";

//   *** Used for testing only ***
// char ReqBuffer[250] = "1 50000 c:\\result.dat use procedure strprmr1 21700100001nnnnnnnnnnbb";
// char ReqBuffer[250] = "2 500000 c:\\result.dat use procedure rspusp1 00001361601992073113181555199200000000000000000000000000000000000000000000";
// char ReqBuffer[250] = "2 500000 c:\\qqf.dat use procedure rspusp1 00002360810000000000000000000000000000000000000000000000000000000000000000";

HWND       workhWnd;
HWND       workhInstance;
DWORD      StartTime, CurrTime, WorkTimeout;
DBINT      StrSize;

DBPROCESS *dbproc = (DBPROCESS *) NULL;
LOGINREC  *login;

HWND       workhWndEdit;
HWND       ghWnd;
HWND       errhWnd;
unsigned   Edit_ID;

int        dbOpenFlag, dbInitFlag, dbHandlersFlag, FlagDblocked;
int        asRC, connectRC, writeRC;
int        UserParmAllocFlag, LibAllocFlag;
int        HostBlockAllocFlag;
int        validateRC, requestRC, responseRC, postRC;
int        ControlMessageFlag = 0;      // Do nothing when windows idle
int        TranInstBase = 990;
WORD       WorkInstanceCode;

char       MsgBuffer[80];              // Buffer for err messages
char       EditControlBuffer[MAXLEN];
char       CommandBuffer[200];

char       Cmd_User[21];           // Data needed for the HOST connect
char       Cmd_Password[21];       //  ------------"-----------------
char       Cmd_Server[21];         //  ------------"-----------------
char       Cmd_Timeout[21];        //  ------------"-----------------
char       Cmd_Instance[2];
char       Cmd_LibName[10];         // DLL LIBRARY NAME
char       Cmd_ExitRoutineName[9]; // DLL Routine Name to be loaded
                                   // dynamically

char       Cmd_Mode[2];
char       Cmd_FlagFileName[101];
char       Cmd_RequestBuffer[201];
char       Cmd_Position[2];

char       szAppName[] = "Asynsrv ";

char       szUserLibName[15];

char       WorkRemoteErrorCode[5];
char      *pWork;
char       FlagRecord[5];
WORD       FlagRecordLength = 5;
WORD       InstanceNumber;

HICON      hIcon1, hIcon2;
long       i;

HANDLE     workInstance;
HWND       workhWnd;
RECT       rect, workRect;

int        RetCod, hResultFile, hFlagFile, RC, CycleError;
RECT       workRect;

MSG        msg;
LPSTR     lpBlock;
int       BlockLength;

BOOL       Result;

OFSTRUCT   OfStruct;




FARPROC lpdbworkMessageHandler;
FARPROC lpdbworkErrorHandler;



// **************************************************************
//      ***  Prototypes  ***
// **************************************************************

long FAR PASCAL WndProc (HWND, WORD, WORD, LONG);

int  MDIasyn (char *ReqString);
int  Connect(void);
int  ValidateInputParams(LPSTR);
int  SendRequest(void);
int  ProcessResponse(void);
void Yield_Control(void);
int ProcessRemoteError (char *);
void CleanUp(void);


// Message & Error Processing Call back functions
int FAR dbwinMessageHandler(DBPROCESS *, DBINT,
                                     DBSMALLINT, DBSMALLINT, LPSTR);
int FAR dbwinErrorHandler(DBPROCESS *, int, int, int, LPSTR, LPSTR);




// ************************************************************
//        *** Main Procedure ***
// ************************************************************

int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdLine, int nCmdShow)

 {


  HWND            hwnd;
  WNDCLASS        wndclass;

  BOOL            bResult;
  static  HDC     hdc;
  // PAINTSTRUCT     ps;
  // TEXTMETRIC      tm;

   //    *** Validate input parameters ***
   validateRC = ValidateInputParams(lpszCmdLine);
   if (validateRC)
       return 1;

// if (!hPrevInstance)
// {
    wndclass.style                = CS_HREDRAW | CS_VREDRAW;
    wndclass.lpfnWndProc          = WndProc;
    wndclass.cbClsExtra           = 0;
    wndclass.cbWndExtra           = 0;
    wndclass.hInstance            = hInstance;
    wndclass.hIcon                = LoadIcon (hInstance, szIconName1);
    wndclass.hCursor              = LoadCursor (hInstance, IDC_ARROW);
    wndclass.hbrBackground        = GetStockObject (WHITE_BRUSH);
    wndclass.lpszMenuName         = (LPSTR) NULL;
    wndclass.lpszClassName        = (LPSTR) szAppName;


    bResult = RegisterClass (&wndclass);

    if (!bResult)
      {
 //    MessageBox (NULL, "Invalid registration", "SYSTEM ERROR",
 //                        MB_ICONHAND | MB_OK);
       _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0150");
       ProcessRemoteError (WorkRemoteErrorCode);
       return 1;
      }

   workhInstance = hInstance;


   // *** Load User Exit DLL routine only if it is present ***
   // *** Must be done only after registration ***
     if ( (LPSTR) lstrcmpi(Cmd_LibName, (LPSTR) "NOEXIT"))
      {
       LibAllocFlag = 0;
       hLibrary = LoadLibrary ((LPSTR) szUserLibName);

       if ( (UINT) hLibrary > 32 )
         {
          LibAllocFlag = 1;
          (FARPROC) lptrAsynUsr = GetProcAddress (hLibrary,
                                               (LPSTR) Cmd_LibName);

           if (lptrAsynUsr == NULL)
             {
              // *** Cannot find the entry in UserExit DLL library ***
              _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0151");
              ProcessRemoteError (WorkRemoteErrorCode);
              return 1;
             }

         }
       else
         {
          // *** Cannot load the UserExit DLL library ***
          _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0152");
          ProcessRemoteError (WorkRemoteErrorCode);
          return 1;
         }

      }


   //    *** Allocate a buffers from the remote heap ***

   HostBlockAllocFlag = 0;
   hHostBlock = GlobalAlloc (GMEM_MOVEABLE, MAX_HOST_BLOCK_SIZE);
   if (hHostBlock == 0)
     {
       // Unsuccessful global heap allocation of the HOST block
       _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0153");
       ProcessRemoteError (WorkRemoteErrorCode);
       return 1;
     }

   HostBlockAllocFlag = 1;             // Block allocated. set flag

   UserParmAllocFlag = 0;
   hUserParm = GlobalAlloc (GMEM_MOVEABLE, 110);
   if (hUserParm == 0)
       // Unsuccessful global heap allocation of the UserParm structure
     {
       _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0154");
       ProcessRemoteError (WorkRemoteErrorCode);
       return 1;
     }

   UserParmAllocFlag = 1;             // Block allocated. Set flag


// *** Successful initialization ***



   FlagDblocked = 0;          // No DBLOCKED has been issued yet

   hwnd = CreateWindow ( (LPSTR) szAppName, (LPSTR) szAppName,
                         WS_OVERLAPPED,
                         GetSystemMetrics (SM_CXSCREEN) - 110,
                         GetSystemMetrics (SM_CYSCREEN) - 60,
                         50, 55,
                         NULL, NULL, hInstance, NULL);


   if (hwnd == NULL)
     {
 //   MessageBox (workhWnd, "Window create failed", "ERROR",
 //                                  MB_ICONHAND | MB_OK);
      _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0155");
      ProcessRemoteError (WorkRemoteErrorCode);
      return 1;
     }


   workhWnd   =    hwnd;
   ghWnd      =    hwnd;
   errhWnd    =    hwnd;

   ShowWindow (hwnd, nCmdShow);
   UpdateWindow (hwnd);


   while (TRUE)
     {
       if (PeekMessage (&msg, NULL, 0, 0, PM_REMOVE))
         {
           // There is a message for this task. Process it

           if (msg.message == WM_QUIT)
              break;

           TranslateMessage (&msg);
           DispatchMessage (&msg);

          }
     else
      {

       // *******************************************************
       // There are no messages in all apps queue.
       // Process consequetive parts of communication logic.
       // *******************************************************

        switch (ControlMessageFlag)
         {

           case 1:

                requestRC = SendRequest();
                StartTime = GetCurrentTime();

                if (requestRC)
                  {
                    // Error sending a request. Quit communication.
                    ControlMessageFlag = 0;
                    InvalidateRect (workhWnd, NULL, 1);

                   // *** Change the icon to free "commun" icon again ***
                   FlashWindow (workhWnd, TRUE);        // hide icon
                   SetClassWord (workhWnd, GCW_HICON, hIcon1);
                   FlashWindow (workhWnd, TRUE);        // hide icon

 //                 PostQuitMessage(0);
                    break;
                   }

                    // The request was successfull. Set a flag
                    // indicating the next action - check the response

                    ControlMessageFlag = 2;
                    break;



           case 2:

                responseRC = ProcessResponse();

                if (responseRC == 1)
                  {
                    // Error processing a HOST response
                    ControlMessageFlag = 4;

                   // *** Change the icon to free "commun" icon again ***
                   FlashWindow (workhWnd, TRUE);        // hide icon
                   SetClassWord (workhWnd, GCW_HICON, hIcon1);
                   FlashWindow (workhWnd, TRUE);        // hide icon

//                  PostQuitMessage(0);
                    break;
                   }


                if (responseRC == 2)
                 {
                   // Still waiting for response
                   ControlMessageFlag = 2;       // Keep checking
                   break;
                  }

                if (responseRC == 0)
                  {
                   // Got the response and put it on disk
                    ControlMessageFlag = 3;
                    break;
                   }


           case 3:

                    ControlMessageFlag = 0;

//                  CleanUp();

//                  SendMessage (0xFFFF, WM_USER, 992, (long) ReqBuffer);
                    break;


         }   // End of the switch statement

      }      // End ELSE logic

    } //  End for while

   CleanUp();

   return msg.wParam;

 }  // End for WinMain



// ********************************************************
//          *** Window Procedure ***
// ********************************************************

long FAR PASCAL WndProc (HWND hwnd, WORD message,
                          WORD wParam, LONG lParam)
 {
  static     int     RetCod;
  static     HWND    hwndEdit;

  static     int     i, ii;


  static     RECT    rect;
  static     HDC     hdc;
  // PAINTSTRUCT        ps;
  // TEXTMETRIC         tm;



  // Pointer to message and error handlers
  static FARPROC lpdbwinMessageHandler;
  static FARPROC lpdbwinErrorHandler;


  Edit_ID = 1;

  dbInitFlag = 0;
  dbHandlersFlag = 0;
  dbOpenFlag = 0;



  switch (message)
   {
    case WM_CREATE:

     if (!dbInitFlag)          // do it first time only
      {
         //   *** Install Message and Error handlers, and    ***
         //   *** DBLIB Call-back functions                  ***

         dbinit();

         dbInitFlag = 1;

         hIcon1 = LoadIcon (workhInstance, (LPSTR) szIconName1);
         hIcon2 = LoadIcon (workhInstance, (LPSTR) szIconName2);

         lpdbwinMessageHandler =
             MakeProcInstance ((FARPROC)dbwinMessageHandler, workhInstance);
         lpdbwinErrorHandler =
             MakeProcInstance ((FARPROC)dbwinErrorHandler, workhInstance);


         // *** Install the instance of dblib ***

         dbmsghandle(lpdbwinMessageHandler);
         dberrhandle(lpdbwinErrorHandler);

         lpdbworkMessageHandler = lpdbwinMessageHandler;
         lpdbworkErrorHandler = lpdbwinErrorHandler;


         dbHandlersFlag = 1;

         // *** Issue a connect request ***

         connectRC = Connect();

         DBUNLOCKLIB();

         if (connectRC)
           {
            PostQuitMessage(0);
           }

//     *** Used for testing only ***
// SendMessage (0xFFFF, WM_USER, WorkInstanceCode, (long) ReqBuffer);


   return 0;               // No default message processing

       }  //  End initialization for 1-st time only

       break;                  // Default processing


      case WM_USER:

        if (wParam == WorkInstanceCode)
         {

          for (i = 0; *((char far *)lParam + i) != '\0'; i++)
              EditControlBuffer[i] = *((char far *)lParam + i);
          EditControlBuffer[i] = '\0';

          // *** Set a flag that we get a request data ***
          ControlMessageFlag = 1;

          // *** Change the icon to busy "clock" icon ***
          FlashWindow (workhWnd, TRUE);        // hide icon
          SetClassWord (workhWnd, GCW_HICON, hIcon2);
          FlashWindow (workhWnd, TRUE);        // hide icon


//      *** Used for testing only ***
//          MessageBox (hwnd, EditControlBuffer, "TEST", MB_ICONHAND | MB_OK);

          return 0;
         }

        break;


    case WM_QUERYOPEN:

          return 0;           // Prevent the user to uniconize the
                              // window


      case WM_CLOSE:
      case WM_DESTROY:                   // window being destoyed                         */

           /* Destroy child windows, modeless dialogs, then, this window  */

           CleanUp();
           break;

   }     // End switch

   return DefWindowProc (hwnd, message, wParam, lParam);

 }


// ********************************************************************
// ***             CONNECT procedure                                ***
// ***  Builds a login records and issues  dbopen.                  ***
// ********************************************************************

int Connect()
 {

   DBLOCKLIB();
   FlagDblocked = 1;

   if (dbproc != (DBPROCESS *) NULL )
      //  *** close any active process ***
      dbclose(dbproc);

       if (FlagDblocked)
        {
         DBUNLOCKLIB();
         FlagDblocked = 0;
        }

  login = dblogin();
  if (login == (LOGINREC *)NULL)  // Nomory allocation problem
    {
//    MessageBox(workhWnd, "Could not allocate Login Record",
//                      "System Error", MB_ICONHAND | MB_OK);

      _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0156");
       ProcessRemoteError (WorkRemoteErrorCode);
       return 1;
     }


     //   *** Login record is ok ***

     DBSETLUSER (login, (char far *) Cmd_User);
     DBSETLPWD  (login, (char far *) Cmd_Password);
     DBSETLAPP  (login, (char far *) szAppName);

     dbproc = dbopen (login, (LPSTR) Cmd_Server);

     if (dbproc == (DBPROCESS *)NULL)
       {
 //     MessageBox(workhWnd, "DBOPEN command failed",
 //                   "System Error", MB_ICONHAND | MB_OK);

        dbOpenFlag = 0;
        dbfreelogin (login);

       if (FlagDblocked)
        {
         DBUNLOCKLIB();
         FlagDblocked = 0;
        }

       _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0157");
        ProcessRemoteError (WorkRemoteErrorCode);
        return 1;
       }

      dbOpenFlag = 1;

       //   *** Successfully connected to the gateway ***

       dbfreelogin (login);

      if (FlagDblocked)
       {
        DBUNLOCKLIB();
        FlagDblocked = 0;
       }

       return 0;         // Successful connection to the HOST

 }   //  End the Connect procedure




 // ******************************************************
 //    *** Validate input parameters ***
 // ******************************************************

 int ValidateInputParams(LPSTR lpworkCmdLine)
  {

   int i, ii, iii;

      Cmd_User[0] = '\0';
      Cmd_Password[0] = '\0';
      Cmd_Server[0] = '\0';
      Cmd_Timeout[0] = '\0';
      Cmd_FlagFileName[0] = '\0';
      Cmd_RequestBuffer[0] = '\0';
      szUserLibName[0] = '\0';

     i = 0;

     for (ii = i, iii = 0; iii < 20;  i++, ii++, iii++)
         {
             if (*(lpworkCmdLine + ii) == ' ')
               break;
             else
               Cmd_User[iii] = *(lpworkCmdLine + ii);
         }

        i++;

         for (ii = i, iii = 0;iii < 20; i++, ii++, iii++)
            {

             if (*(lpworkCmdLine + ii) == ' ')
               break;
             else
               Cmd_Password[iii] = *(lpworkCmdLine + ii);
            }

      i++;

         for (ii = i, iii = 0;iii < 20; i++, ii++, iii++)
            {

             if (*(lpworkCmdLine + ii) == ' ')
               break;
             else
               Cmd_Server[iii] = *(lpworkCmdLine + ii);
            }

      i++;

         for (ii = i, iii = 0;iii < 98; i++, ii++, iii++)
            {

             if (*(lpworkCmdLine + ii) == ' ')
               break;
             else
               Cmd_FlagFileName[iii] = *(lpworkCmdLine + ii);
            }

      i++;

         for (ii = i, iii = 0;iii < 9; i++, ii++, iii++)
            {

             if (*(lpworkCmdLine + ii) == ' ')
               break;
             else
               Cmd_LibName[iii] = *(lpworkCmdLine + ii);
            }

      i++;

         for (ii = i, iii = 0;iii < 2; i++, ii++, iii++)
            {

             if (*(lpworkCmdLine + ii) == '\0')
               break;
             else
               Cmd_Instance[iii] = *(lpworkCmdLine + ii);
            }



   //  *** Check parsed results ***

     if (Cmd_FlagFileName[0] == '\0')
       {
//      MessageBox (workhWnd, "Missing FlagFile name parameter", "ERROR",
//                                   MB_ICONHAND | MB_OK);
       _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0179");
        ProcessRemoteError (WorkRemoteErrorCode);
        return 1;
       }


     if (Cmd_User[0] == '\0')
       {
 //     MessageBox (workhWnd, "Missing User ID parameter", "ERROR",
 //                                  MB_ICONHAND | MB_OK);

       _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0158");
        ProcessRemoteError (WorkRemoteErrorCode);
        return 1;
       }

     if (Cmd_Password[0] == '\0')
       {
 //     MessageBox (workhWnd, "Missing Password parameter", "ERROR",
 //                                  MB_ICONHAND | MB_OK);

       _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0159");
        ProcessRemoteError (WorkRemoteErrorCode);
        return 1;
       }

     if (Cmd_Server[0] == '\0')
       {
 //     MessageBox (workhWnd, "Missing Server name parameter", "ERROR",
 //                                  MB_ICONHAND | MB_OK);
       _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0160");
        ProcessRemoteError (WorkRemoteErrorCode);
        return 1;
       }

     if (Cmd_Instance[0] == '\0')
       {
 //     MessageBox (workhWnd, "Missing the Instance parameter", "ERROR",
 //                                  MB_ICONHAND | MB_OK);
       _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0161");
        ProcessRemoteError (WorkRemoteErrorCode);
        return 1;
       }

     if ((Cmd_Instance[0] >  '9') ||
        (Cmd_Instance[0] <  '0'))
       {
 //     MessageBox (workhWnd, "Invalid Instance value", "ERROR",
 //                                  MB_ICONHAND | MB_OK);
       _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0162");
        ProcessRemoteError (WorkRemoteErrorCode);
        return 1;
       }

     if (Cmd_LibName[0] == '\0')
       {
 //     MessageBox (workhWnd, "Missing DLL LibName parameter", "ERROR",
 //                                  MB_ICONHAND | MB_OK);
       _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0163");
        ProcessRemoteError (WorkRemoteErrorCode);
        return 1;
       }

 // *** The Instance is correct. Update the utility name
 // *** (Before registration) ***
     szAppName[7] = Cmd_Instance[0];

 // *** The entry name = the UserExit.DLL name
       _fstrcpy ((LPSTR) szUserLibName, (LPSTR) Cmd_LibName);
       _fstrcat ((LPSTR) szUserLibName, (LPSTR) ".DLL");

     InstanceNumber = atoi(Cmd_Instance);
     WorkInstanceCode = TranInstBase + InstanceNumber;

     return 0;

 }     //    *** End of parameters validation  ***


 void CleanUp()
    {

 //     if (FlagDblocked)
 //       {
 //        DBUNLOCKLIB();
 //        FlagDblocked = 0;
 //       }

         if (dbOpenFlag)                  // Exit application
           {
            dbclose(dbproc);
            dbOpenFlag = 0;
           }

         if (dbInitFlag)                   // Exit application
           {
            dbwinexit();
            dbInitFlag = 0;
           }

         if (dbHandlersFlag)               // Exit appliaction
           {
            FreeProcInstance (lpdbworkMessageHandler);
            FreeProcInstance (lpdbworkErrorHandler);
            dbHandlersFlag = 0;
           }

         if (HostBlockAllocFlag)
          {
           GlobalFree (hHostBlock);          // Exit application
           HostBlockAllocFlag = 0;
          }

         if (UserParmAllocFlag)              // Exit application
          {
           GlobalFree (hUserParm);
           UserParmAllocFlag = 0;
          }

         if (LibAllocFlag)                  // Exit application
          {
           FreeLibrary(hLibrary);
           LibAllocFlag = 0;
          }
     }


 //  *********************************************************
 //       ***  Send an asynch. request to the HOST
 //  *********************************************************

 int SendRequest()
  {

    int   i, ii;

     // *** get request data to be submitted ***


     //  *** Check for server kill request

     if ( EditControlBuffer[0] == 'K')
       if ( EditControlBuffer[1] == 'I')
        if ( EditControlBuffer[2] == 'L')
         if ( EditControlBuffer[3] == 'L')
           {
//          CleanUp();
            PostQuitMessage(0);      // Terminate the application
            return 0;
           }


     //  *** Parse data sent by the user message   ***

     for (i = 0, ii = 0; EditControlBuffer[i] != ' '; i++, ii++)
        {
          if (i > 1)
             break;

          Cmd_Mode[ii] = EditControlBuffer[i];
        }

          Cmd_Mode[ii] = '\0';

     i++;

     for (i = i, ii = 0; EditControlBuffer[i] != ' '; i++, ii++)
        {
          if (i > 15)
             break;

          Cmd_Timeout[ii] = EditControlBuffer[i];
        }

          Cmd_Timeout[ii] = '\0';

     i++;

     lpUserParm = (LPUSERPARM) GlobalLock (hUserParm);
     lpUserParm->Cmd_ResultFileName[0] = '\0';
     for (i = i, ii = 0; EditControlBuffer[i] != ' '; i++, ii++)
        {
          if (ii > 98)
             break;
          lpUserParm->Cmd_ResultFileName[ii] = EditControlBuffer[i];
        }
 //     ii++;
        lpUserParm->Cmd_ResultFileName[ii] = '\0';

     GlobalUnlock (hUserParm);

     i++;

     for (i = i, ii = 0; EditControlBuffer[i] != '\0'; i++, ii++)
        {
          if (ii > 199)
             break;

          Cmd_RequestBuffer[ii] = EditControlBuffer[i];
        }

          Cmd_RequestBuffer[ii] = '\0';



    if (Cmd_Mode[0] == '\0')
     {
      // *** Missing Mode parameter ***
       _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0164");
        ProcessRemoteError (WorkRemoteErrorCode);
        return 1;
     }


    if (Cmd_Mode[0] < '1')
     {
      // Invalid values for the Mode parameter
       _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0165");
        ProcessRemoteError (WorkRemoteErrorCode);
        return 1;
     }

    if (Cmd_Mode[0] > '2')
     {
      // Invalid values for the Mode parameter
       _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0165");
        ProcessRemoteError (WorkRemoteErrorCode);
        return 1;
     }

 // *** If NOEXIT passed as a parameter parameter 2 is invalid ***

     if ( (LPSTR) lstrcmpi(Cmd_LibName, (LPSTR) "NOEXIT") == 0)
       {
        if (Cmd_Mode[0] == '2')
         {
         // Mode 2 is invalid NOEXIT routine specified
         _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0166");
         ProcessRemoteError (WorkRemoteErrorCode);
         return 1;
         }
       }

    if (Cmd_Timeout[0] == '\0')
     {
      // Missing Timeout parameter
      _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0167");
       ProcessRemoteError (WorkRemoteErrorCode);
       return 1;
     }

    //  Convert Timeout to long
    WorkTimeout = atol(Cmd_Timeout);



   if (lpUserParm->Cmd_ResultFileName[0] == '\0')
     {
      // Missing Response File Name parameter
      _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0168");
       ProcessRemoteError (WorkRemoteErrorCode);
       return 1;
     }


   if (Cmd_RequestBuffer[0] == '\0')
     {
      // Missing Request string parameter
      _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0169");
       ProcessRemoteError (WorkRemoteErrorCode);
     }


   //  ***  End of parameters validation ***



    //   ***  Asynchronous comm request ***
         asRC = MDIasyn (Cmd_RequestBuffer);
                           //    "use procedure strprmr1 21700100001nnnnnnnnnnbb");

         if (asRC)
           {
           // Request rejected
           _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0170");
            ProcessRemoteError (WorkRemoteErrorCode);
           }


       //  *** Open ResultFile only if Mode 1;


        if (Cmd_Mode[0] == '1')
         {

 //        MessageBox (NULL, lpUserParm->Cmd_ResultFileName, "ERROR", MB_OK);


           hResultFile = OpenFile ((LPCSTR)
                lpUserParm->Cmd_ResultFileName, (LPOFSTRUCT) &OfStruct,
                                           OF_CREATE | OF_READWRITE);
 //                           OF_SHARE_DENY_NONE | OF_CREATE | OF_READWRITE);

           if (hResultFile == -1)
            {
             // Open ResultFile dataset failed
             wsprintf (WorkBuffer, "Error code = %d", OfStruct.nErrCode);
             MessageBox (NULL, WorkBuffer, "ERROR", MB_OK);
             _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0171");
             ProcessRemoteError (WorkRemoteErrorCode);
             return 1;
            }
         }

         return 0;


 }     //   End of SendRequest procedure




// *****************************************************************
//
//      ***  SEND ASYNCHRONOUS REQUEST FOR HOST DATA ***
//
// *****************************************************************

int MDIasyn (char *ReqString)
 {
    if (dbproc == (DBPROCESS *) NULL)
     {
       // Invalid process
      _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0172");
       ProcessRemoteError (WorkRemoteErrorCode);
       return 1;
     }

     if (dbcmd (dbproc, ReqString) == FAIL)
       {
         // DBFCMD command failed
         _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0173");
          ProcessRemoteError (WorkRemoteErrorCode);
          return 1;
        }


     // *** Send an asynchronous request ***

     if (dbsqlsend(dbproc) == FAIL)
       {
         // dbsqlsend command failed
         _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0174");
          ProcessRemoteError (WorkRemoteErrorCode);
          return 1;
       }


       return 0;

   }      //   End of MDIAsyn


   // ************************************************
   // ***  Check if the response is ready ***
   // ***  When waiting for the response yeld control
   // ***  to other tasks. When the response is ready,
   // ***  write it on the disk.
   // ************************************************

   int ProcessResponse()
    {

       int AsynRC;
       long n;

       n = 0L;

       CycleError = 0;

       CurrTime = GetCurrentTime();

       if ((CurrTime - StartTime) > WorkTimeout)
        {
          // No response from the HOST, Timeout
         _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0175");
          ProcessRemoteError (WorkRemoteErrorCode);
          return 1;
        }

       // If no timeout, check if the response is redy ***

       Result = dbdataready(dbproc);


       if (Result != TRUE)       // Response is not available yet
         {
           ControlMessageFlag = 2;       // Keep checking for response
           return (2);
         }


        // ***  Get the response record  ***

        // Get the result - everething what RSP sends in response to the
        // request

        DBLOCKLIB();
        FlagDblocked = 1;

        ControlMessageFlag = 0;
        CycleError = 0;

        while ((RetCod = dbresults(dbproc)) != NO_MORE_RESULTS)
          {
           if (RetCod == SUCCEED)
            {

             while (dbnextrow(dbproc) != NO_MORE_ROWS)
              {
                lpBlock = (LPSTR) dbdata(dbproc, 1);     // pointer to the block
                                                // returned by dbdata

                // Calculate the number of record in the block and
                // write all block records on disk
                 BlockLength = (int) dbdatlen(dbproc, 1);
                 if (BlockLength == -1)
                  {
  //                MessageBox(workhWnd, "BlockLength command failed",
  //                         "System Error", MB_ICONHAND | MB_OK);
                   _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0176");
                    ProcessRemoteError (WorkRemoteErrorCode);

                    CycleError = 1;       // Quit the application

                    break;
                  }

                // *** Move it to the buffer and lock
                lpHostBlock = GlobalLock (hHostBlock);
                _fmemcpy ((LPSTR) lpHostBlock, (LPSTR) lpBlock, BlockLength);

                // *** Insure that the block is a null terminated string
                lpHostBlock[BlockLength] = '\0';

                GlobalUnlock (hHostBlock);

                  // If Mode = 1 then write the block to the disk file
                  // If Mode = 2 then call AsynUsr2.DLL passing the
                  //    retrieved record as a paramerter


                 if (Cmd_Mode[0] == '1')
                  {

                   // Write the retrieved block to the Result File;
                   // If OK, continue processing

                   writeRC = _lwrite (hResultFile, (LPCSTR) lpBlock,
                                             (UINT) BlockLength);

                   if (writeRC == -1 )
                     {

                       // _lwrite to ResultFile failed
                       _fstrcpy ((LPSTR) WorkRemoteErrorCode,
                                                   (LPSTR) "0177");
                       ProcessRemoteError (WorkRemoteErrorCode);
                       CycleError = 1;     // Quit the communication

                      }


                     //  The block is written on disk
                     //  Yield control, then
                     //  Go get the next block

 //                   Yield_Control();

                  }

                 else

                  // Processing mode 2.
                  // Call a user routine AsynUsrN.dll and pass the
                  // retrieved string as a parameter
                  {

                    lpUserParm = (LPUSERPARM) GlobalLock (hUserParm);
                    _fstrcpy ((LPSTR) lpUserParm->UserErrCode, (LPSTR) "0000");

                    lpHostBlock = GlobalLock (hHostBlock);

                     AsynRC = (*lptrAsynUsr) ( (LPSTR) lpHostBlock,
                                               BlockLength,
                                               (LPSTR) lpUserParm->Cmd_ResultFileName,
                                               (LPSTR) lpUserParm->UserErrCode );

                    GlobalUnlock (hUserParm);
                    GlobalUnlock (hHostBlock);

                    CycleError = AsynRC;

                    switch (AsynRC)
                     {
                        case 0:  // Successful processing in Exit Routine

                           break;        // Continue processing


                        case 1:  // Write the User Err Code to the
                                 // FlagFile and quit communication

                           lpUserParm = (LPUSERPARM) GlobalLock (hUserParm);
                           _fstrcpy ((LPSTR) WorkRemoteErrorCode,
                                       (LPSTR) lpUserParm->UserErrCode);
                           GlobalUnlock (hUserParm);
                           ProcessRemoteError (WorkRemoteErrorCode);
                           return 1;                 // Quit communication



                        case 2:  // Write the User Err Code to the FlagFile
                                 // and continue communication

                           lpUserParm = (LPUSERPARM) GlobalLock (hUserParm);
                           _fstrcpy ((LPSTR) WorkRemoteErrorCode,
                                       (LPSTR) lpUserParm->UserErrCode);
                           GlobalUnlock (hUserParm);
                           ProcessRemoteError (WorkRemoteErrorCode);

                           break;       // Continue communication


                    }     // End of swith statement

                  }  // End else for processing mode 2


                   // *** Yield control before processing the next record ***
                    Yield_Control();

              }   // End while

            }    // End if

          }  // End while


        if (CycleError)  // In case of successfull result write
            return CycleError;     // Error during processing

        // Successfull result. Write "0000" User code

         // ***   Write the FlagRecord to a FlagFile
         // has been already written
         // For unsuccessfull result the User Code
         // ***   to indicate successfull processing

        _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0000");
        ProcessRemoteError (WorkRemoteErrorCode);

        // *** In Mode = 1, close the ResultFile

        if (Cmd_Mode[0] == '1')
          {
           if (_lclose(hResultFile) == -1)
            {
             // _lclose ResultFile failed
             _fstrcpy ((LPSTR) WorkRemoteErrorCode, (LPSTR) "0178");
             ProcessRemoteError (WorkRemoteErrorCode);

             }
          }


          // *** Change the icon to free "commun" icon again ***
          FlashWindow (workhWnd, TRUE);        // hide icon
          SetClassWord (workhWnd, GCW_HICON, hIcon1);
          FlashWindow (workhWnd, TRUE);        // hide icon


        ControlMessageFlag = 0;             // Commun. logic is done

//      CleanUp();

        if (FlagDblocked)
         {
          DBUNLOCKLIB();
          FlagDblocked = 0;
         }

        return 0;         // Successfull end of response processing

   }   // End of the ProcessResponse  procedure



   // ************************************************
   // ***  Yield control to other tasks   ***
   // ************************************************

   void Yield_Control()
    {
     FlashWindow (workhWnd, FALSE);
     PeekMessage (&msg, workhWnd, 0, 0, PM_NOREMOVE);
     FlashWindow (workhWnd, FALSE);
     PeekMessage (&msg, workhWnd, 0, 0, PM_NOREMOVE);
     FlashWindow (workhWnd, FALSE);
     PeekMessage (&msg, workhWnd, 0, 0, PM_NOREMOVE);
     FlashWindow (workhWnd, FALSE);
    }



// ************************************************************
//     *** Message and Errors Processing Functions ***
// ************************************************************

int FAR dbwinMessageHandler(DBPROCESS *dbproc,
                          DBINT msgno,
                          DBSMALLINT msgstate,
                          DBSMALLINT severity,
                          LPSTR msgtext)


 {
  MessageBox(GetActiveWindow(), msgtext, (LPSTR)"SQL DataServer Message",
                                                     MB_OK);

   return(0);
 }



 int FAR dbwinErrorHandler(dbproc, severity, errno, oserr,
                                          dberrstr, oserrstr)
 DBPROCESS *dbproc;
 int severity;
 int errno;
 int oserr;
 LPSTR dberrstr;
 LPSTR oserrstr;
 {
     MessageBox(GetActiveWindow() ,dberrstr,(LPSTR)"DB-LIBRARY error",
                                         MB_ICONHAND | MB_OK);



    if (oserr != DBNOERR)     /* os error     */
     {

       MessageBox(GetActiveWindow(), oserrstr,(LPSTR)"Operating-System error",
                                            MB_ICONHAND | MB_OK);

     }

    return(INT_CANCEL); /* cancel command */

 }



 // ************************************************
 // ***  Write error code into a flag file ***
 // ************************************************

 int ProcessRemoteError (char * WorkRemoteErrorCode)
  {
      hFlagFile = OpenFile ((LPSTR) Cmd_FlagFileName, (LPOFSTRUCT) &OfStruct,
                                            OF_CREATE | OF_READWRITE);

      if (hFlagFile == -1)
        {
         MessageBox(GetActiveWindow(), "Open FlagFile dataset failed",
                       "System Error", MB_ICONHAND | MB_OK);
         PostQuitMessage(0);
         return 1;
        }


      _lwrite (hFlagFile,  (LPCSTR) WorkRemoteErrorCode,
                            (UINT) FlagRecordLength);

      if (writeRC == -1 )
        {

          MessageBox(GetActiveWindow(), "_lwrite to FlagFile failed",
                           "System Error", MB_ICONHAND | MB_OK);


          PostQuitMessage(0);
          return 1;
        }

         if (_lclose(hFlagFile) == -1)
           {
            MessageBox (GetActiveWindow(), "_lclose FlagFile failed",
                              "System Error", MB_ICONHAND | MB_OK);

             PostQuitMessage(0);
             return 1;
           }

           return 0;     // FileFlag IO is done

 }        // End of ProcessRemoteError()
